clang 10.0.0git

Public Member Functions | Static Public Member Functions | List of all members
clang::SemaConsumer Class Reference

An abstract interface that should be implemented by clients that read ASTs and then require further semantic analysis of the entities in those ASTs. More...

`#include "clang/Sema/SemaConsumer.h"`

Inheritance diagram for clang::SemaConsumer:
[legend]
Collaboration diagram for clang::SemaConsumer:
[legend]

## Public Member Functions
| SemaConsumer ()
virtual void | InitializeSema (Sema &S)
| Initialize the semantic consumer with the Sema instance being used to perform semantic analysis on the abstract syntax tree. More...
virtual void | ForgetSema ()
| Inform the semantic consumer that Sema is no longer available. More...
Public Member Functions inherited from clang::ASTConsumer
| ASTConsumer ()
virtual | ~ASTConsumer ()
virtual void | Initialize (ASTContext &Context)
| Initialize - This is called to initialize the consumer, providing the ASTContext. More...
virtual bool | HandleTopLevelDecl (DeclGroupRef D)
| HandleTopLevelDecl - Handle the specified top-level declaration. More...
virtual void | HandleInlineFunctionDefinition (FunctionDecl *D)
| This callback is invoked each time an inline (method or friend) function definition in a class is completed. More...
virtual void | HandleInterestingDecl (DeclGroupRef D)
| HandleInterestingDecl - Handle the specified interesting declaration. More...
virtual void | HandleTranslationUnit (ASTContext &Ctx)
| HandleTranslationUnit - This method is called when the ASTs for entire translation unit have been parsed. More...
virtual void | HandleTagDeclDefinition (TagDecl *D)
| HandleTagDeclDefinition - This callback is invoked each time a TagDecl (e.g. More...
virtual void | HandleTagDeclRequiredDefinition (const TagDecl *D)
| This callback is invoked the first time each TagDecl is required to be complete. More...
virtual void | HandleCXXImplicitFunctionInstantiation (FunctionDecl *D)
| Invoked when a function is implicitly instantiated. More...
virtual void | HandleTopLevelDeclInObjCContainer (DeclGroupRef D)
| Handle the specified top-level declaration that occurred inside and ObjC container. More...
virtual void | HandleImplicitImportDecl (ImportDecl *D)
| Handle an ImportDecl that was implicitly created due to an inclusion directive. More...
virtual void | CompleteTentativeDefinition (VarDecl *D)
| CompleteTentativeDefinition - Callback invoked at the end of a translation unit to notify the consumer that the given tentative definition should be completed. More...
virtual void | CompleteExternalDeclaration (VarDecl *D)
| CompleteExternalDeclaration - Callback invoked at the end of a translation unit to notify the consumer that the given external declaration should be completed. More...
virtual void | AssignInheritanceModel (CXXRecordDecl *RD)
| Callback invoked when an MSInheritanceAttr has been attached to a CXXRecordDecl. More...
virtual void | HandleCXXStaticMemberVarInstantiation (VarDecl *D)
| HandleCXXStaticMemberVarInstantiation - Tell the consumer that this. More...
virtual void | HandleVTable (CXXRecordDecl *RD)
| Callback involved at the end of a translation unit to notify the consumer that a vtable for the given C++ class is required. More...
virtual ASTMutationListener * | GetASTMutationListener ()
| If the consumer is interested in entities getting modified after their initial creation, it should return a pointer to an ASTMutationListener here. More...
virtual ASTDeserializationListener * | GetASTDeserializationListener ()
| If the consumer is interested in entities being deserialized from AST files, it should return a pointer to a ASTDeserializationListener here. More...
virtual void | PrintStats ()
| PrintStats - If desired, print any statistics. More...
virtual bool | shouldSkipFunctionBody (Decl *D)
| This callback is called for each function if the Parser was initialized with `SkipFunctionBodies` set to `true`. More...

## Static Public Member Functions
static bool | classof (const ASTConsumer *Consumer)

## Detailed Description

An abstract interface that should be implemented by clients that read ASTs and then require further semantic analysis of the entities in those ASTs.

Definition at line 25 of file SemaConsumer.h.

## Constructor & Destructor Documentation

## ◆ SemaConsumer()

clang::SemaConsumer::SemaConsumer | ( |  | ) |
| inline

Definition at line 28 of file SemaConsumer.h.

## Member Function Documentation

## ◆ classof()

static bool clang::SemaConsumer::classof | ( | const ASTConsumer * | Consumer | ) |
| inline static

Definition at line 41 of file SemaConsumer.h.

## ◆ ForgetSema()

virtual void clang::SemaConsumer::ForgetSema | ( |  | ) |
| inline virtual

Inform the semantic consumer that Sema is no longer available.

Reimplemented in clang::MultiplexConsumer.

Definition at line 38 of file SemaConsumer.h.

## ◆ InitializeSema()

virtual void clang::SemaConsumer::InitializeSema | ( | Sema & | S | ) |
| inline virtual

Initialize the semantic consumer with the Sema instance being used to perform semantic analysis on the abstract syntax tree.

Reimplemented in clang::PCHGenerator, and clang::MultiplexConsumer.

Definition at line 35 of file SemaConsumer.h.

The documentation for this class was generated from the following files:

- include/clang/Sema/SemaConsumer.h
- lib/Sema/SemaConsumer.cpp